%  USING$ 


% USING$          -форматирование строки, чисел, вывода даты, времени
% FORMAT_USING$   -аналогичная команда (форматирование строки без ее вывода)
% вроде разницы между ними не увидел


%  %  -начало инструкций форматирования
%  %d  -вывод целого числа
%  %f  -вывод дробного числа
%  %e, %E  -вывод в экспоненциальной форме
%  %g, %G  -бейсик сам решает в какой форме выводить число 
%  %s, %S  -вывод строки
%  %n  -не читается выражение или выводит в столбик
%  ,  -разделение числа на тысячи пробелами
%  <  -повторная модификация
%  (  -если число отрицательное- будет выведено в скобках
%  .7  -количество выводимых цифр после запятой
%  -  -позволяет отодвинуть сообщение от левого края на нужное расстояние
%  +  -если число положительное, перед ним будет стоять +
%  $  -определяет номер нужного нам аргумента (числа, строки, над которыми произ-
% водим манипуляции)

%  %tr  -выводит часы, минуты, секунды в 12-часовом формате
%  %tT  -в 24-часовом формате
%  %tR  -в 24-часовом без вывода секунд
%  %tY  -выводит полный год
%  %ty  -выводит последние 2 цифры года
%  %te  -число месяца
%  %td  -число месяца с ведущим нулем
%  %tm  -месяц цифрой
%  %tB  -полное название месяца
%  %tb  -сокращенное
%  %tA  -полное название дня недели
%  %ta  -сокращенное
%  %tI  -час в 12-часовом формате, ведущий ноль отображается
%  %tl  -час в 12-часовом формате, ведущий ноль не отображается
%  %tH  -час в 24-часовом, ведущий ноль отображается
%  %tk  -час в 24-часовом, ведущий ноль не отображается
%  %tM  -минуты
%  %tS  -секунды
%  %tL  -миллисекунды
%  %tp  -выводит am или pm
%  %tj  -день в году
%  %tz  -смещение относительно гринвичского времени
%  %tZ  -временной пояс
%  %tc  -полные сведения о дате и времени
%  %tD  -выводит месяц, число, год
%  %tF  -год, месяц, число



? "==== пример 1 ===="                  

x= 200000000.89
x$= USING$ ("", "напечатаем число %,20d %<13d", int(x))
? x$

%  "" -регион по умолчанию, как в смартфоне
%  "%20d" -модификатор числа, строки, 20 -количество символов для печати,
% если число меньше количества символов для печати, перед числом будет добавлено
% недостающее количество пробелов
%  d - вывод целого числа
%  int(x) -наши данные
%  , (запятая) -число будет разделятся на тысячи пробелами
%  < (знак меньше) - позволяет повторно модифицировать наше число (строку)
% если так: ("", "напечатаем число %24d", x) -будет ошибка, в бейсике можно
% вывести целое число только int(x)
% еще команды для вывода чисел: bin(), oct(), hex(), ceil(), floor(), ascii(),
% ucode(), band(), bor(), bxor(), shift(), time()
? ""


? "==== пример 2 ===="

y= -32843.197
x$= USING$ ("", "%.3f %<(15.3f", y)

%  f -вывод дробного числа
%  15.3 -15 -количество символов для печати, .3 -три цифры после запятой
%  ( -отрицательное число будет выведено в скобках
? x$
? ""


? "==== пример 3 ===="

x$= USING$ ("", "%-30.3f напечатали", y)

%  - (знак минус) -"напечатали" отодвинется от левого края на 30 пробелов
? x$
? ""


? "==== пример 4===="

x$= USING$ ("", "%E     %<g", y)

%  E -вывели число в экспоненциальной форме
%  g -бейсик сам решил, в какой форме выводить число: в простой или экспоне... :)
%  расстояние между %E и %<g влияет на расстояние между выводимыми числами
? x$
? ""


? "==== пример 5 ===="

y$= "выводим все в столбик"
x$= USING$ ("", "%d %n %f %n %s", int(x), y, y$)

 %  %n -в такой конструкции будет выводить все в столбик
? x$
? ""


? "==== пример 6 ===="

x$= USING$ ("", "%n", y)
? x$; "  здесь ничего не вывелось  :)"
? ""


? "==== пример 7 ===="

x$= USING$ ("", "%3$s %2$s %1$s", "первый", "второй", "третий")

 % определили порядок вывода
? x$
? ""


? "==== пример 8 ===="

x$= USING$ ("", "Время  %tr", time())
x2$= USING$ ("", "%tT", time())

%  %tr -вывели часы, минуты, секунды в 12-часовом формате
%  %tT -то-же в 24-часовом
%  %tR -в 24-часовом без секунд
? x$
? x2$
? ""


? "==== пример 9 ===="

x$= USING$ ("", "%tY  %<te %<tB  %<tA  %<tI: %<tM. %<tS %<tp", time())

%  tY -полный год, ty -2 последние цифры года
%  te -число месяца без ведущего нуля
%  td -число месяца с ведущим нулем
%  tm -месяц цифрой
%  tB -полное название месяца, tb -сокращенное
%  tA -полное название дня недели, ta -сокращенное
%  tI -час в 12- часовом формате, ведущий ноль отображается
%  tl -час в 12-часовом формате, ведущий ноль не отображается
%  tH -час в 24-часовом, ведущий ноль отображается 
%  tk -час в 24-часовом, ведущий ноль не отображается
%  tM -минуты
%  tS -секунды
%  tL -миллисекунды
%  tp -pm, am
%  tj -день в году
%  tz -смещение относительно гринвичского времени
%  tZ -временной пояс
%  tc -полные сведения о дате и времени
? x$
? ""


? "==== пример 10 ===="

x$= USING$ ("", "%tD", time())

%  tD -месяц, число, год
%  tF -год, месяц, число
? x$
? ""

end
